/*
    Insertion sort.
*/

#include <stdio.h>


int insertionSort(int* array, int size)
{
    for (int i = 1; i < size; i++) {
        int j = i;

        while (j > 0 && array[j] < array[j-1]) {
                int temp = array[j-1];
                array[j-1] = array[j];
                array[j] = temp;
            j--;
        }
     }
    return 0;
}


int insertionSort2(int* array, int size)
{
    for (int i = 1; i < size; i++) {
        
        for (int j = i; j > 0 && array[j] < array[j-1]; j--) {
                int temp = array[j-1];
                array[j-1] = array[j];
                array[j] = temp;
        }
     }
    return 0;
}



int main(void)
{
    int array[] = {12, 11, 3, 5, 6};
    int array2[] = {12, 11, 3, 5, 6};

    for (int i = 0; i < 5; i++) {
        printf("%d ", array[i]);
    }
    putchar('\n');

    for (int i = 0; i < 5; i++) {
        printf("%d ", array2[i]);
    }
    putchar('\n');

    insertionSort(array, 5);
    insertionSort2(array2, 5);

    for (int i = 0; i < 5; i++) {
        printf("%d ", array[i]);
    }

    putchar('\n');
    for (int i = 0; i < 5; i++) {
        printf("%d ", array2[i]);
    }
    putchar('\n');

    return 0;
}
